/* <insert program name here>
   Copyright (C) 2007,2008  Ingo Korb <ingo@akana.de>


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License only.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


   timer.c: System timer

*/

#include "config.h"
#include <avr/interrupt.h>
#include <avr/io.h>
#include "avrcompat.h"
#include "timer.h"

volatile tick_t ticks;

/* The main timer interrupt */
ISR(TIMER1_COMPA_vect) {
  ticks++;
}

void timer_enable(void) {
  TIMSK1 |= _BV(OCIE1A);
}

void timer_disable(void) {
  TIMSK1 &= (uint8_t)~_BV(OCIE1A);
}

void timer_init(void) {
  /* Set up a 100Hz interrupt using timer 1 */
  OCR1A  = 1250*((float)F_CPU/8000000.0) -1;
  TCNT1  = 0;
  TCCR1A = 0;
  TCCR1B = _BV(WGM12) | _BV(CS10) | _BV(CS11);
  timer_enable();
}
